<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "visit_reason".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "VisitReason".
 *
 * Columns in table "visit_reason" available as properties of the model,
 * followed by relations of table "visit_reason" available as properties of the model.
 *
 * @property integer $id
 * @property integer $all_specialties
 * @property string $name
 * @property integer $standard_visit_duration
 *
 */
abstract class BaseVisitReason extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function getName()
    {
        $visitReason = VisitReason::model()->findByPk($this->id);
        return addslashes($visitReason->name);
    }

    public function tableName()
    {
        return 'visit_reason';
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name', 'required'),
            array('name', 'length', 'max' => 50),
            array('all_specialties, standard_visit_duration', 'numerical', 'integerOnly' => true),
            array('id, name', 'safe', 'on' => 'search'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'all_specialties' => Yii::t('app', 'All Specialties'),
            'standard_visit_duration' => Yii::t('app', 'Standard Visit Duration'),
            'account_id' => Yii::t('app', 'Account ID'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('all_specialties', $this->all_specialties, true);
        $criteria->compare('standard_visit_duration', $this->standard_visit_duration, true);
        $criteria->compare('account_id', $this->account_id, true);
        $criteria->compare('status', 0, true); // status 1 = logical delete

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Visit Reason|Visit Reasons', $n);
    }

}
